clear all;
x1=zeros(1,2)';  % set nodes
x2=[0:.5:1]';
x=[x1;x2];
y1=zeros(1,2)'+1;
y2=[0:.5:1]';
y=[y2;y1];
nnodes=length(x); %number of nodes
nele=nnodes-1; %number of elements
dt=1e-3; %time step
ttime=500e-3; %total run time
ts=round(ttime/dt+1);%# of time steps
gamma=1; %arbitraily value
dgamma=0;
T=800;% annealing temperature, degree
R= 1.986;%Cal/K mol
if T>790
    M=1.9*exp(-57200/(R*(T+273.15)))*1e14;% nm^2/s Buffington, Self Diffusion in Iron ACTA Metallufixca, 9(1961)
else
    M=2.0*exp(-60000/(R*(T+273.15)))*1e14;% nm^2/s Buffington, Self Diffusion in Iron ACTA Metallufixca, 9(1961)
end
L=M*1e-6;%1e-6*M/lengthScale^2, diffusion dominant
H=zeros(nnodes*4-1);%Set dimensions for H
X=zeros(nnodes*4-1,1);
f=zeros(nnodes*4-1,1);
theata=zeros(nele,1);
meshmin=.05;
meshmax=.3;
change=zeros(1,ts);
for i=1:nele %define element end points
    elem(i,1)=i;
    elem(i,2)=i+1;
end
[Helem theata l] = getHelemRev3(nele,x,y,elem,L,M);
[felem] = getfelemRev3(nele,gamma,dgamma,theata);
[H f] = getHfRev3(H,f,felem,Helem,nele,L);
X=H\f; %Multiply to get the X vector
x(1)=X(1)*dt+x(1); %Calculate coordinates for the first node
y(1)=X(2)*dt+y(1);
for j=2:nnodes
    x(j)=X(4+(j-2)*4)*dt+x(j); %Calculate x coordinates at end of timestep
    y(j)=X(5+(j-2)*4)*dt+y(j); %Calculate y coordinates at end of timestep
end
for i=1:ts
    m=nnodes;
    k=1;
    while k<m
        if nele<100
        if sqrt((x(k)-x(k+1))^2+(y(k)-y(k+1))^2)<meshmin % Remove node when the distance between them less than meshmin
            if k==1
                x(k+1)=[];
                y(k+1)=[];
            else
                x(k)=[];
                y(k)=[];
            end
            nele=nele-1;
            nnodes=nnodes-1;
            for n=k:nele %define element end points
                elem(n,1)=n;
                elem(n,2)=n+1;
            end
            m=m-1;
        else if sqrt((x(k)-x(k+1))^2+(y(k)-y(k+1))^2)>meshmax  % add node when the distance between them larger than meshmax
                x=cat(1,x(1:k),(x(k+1)-x(k))/2+x(k),x(k+1:end));
                y=cat(1,y(1:k),(y(k+1)-y(k))/2+y(k),y(k+1:end));
                nele=nele+1;
                nnodes=nnodes+1;
                for n=k:nele %define element end points
                    elem(n,1)=n;
                    elem(n,2)=n+1;
                end
                m=m+1;
            end
        end
        end
        k=k+1;
    end
    
    %xt(:,i+1)=x(:); %store new coordinates
    %yt(:,i+1)=y(:);
    clear Helem theata l;
    [Helem theata l]= getHelemRev3(nele,x,y,elem,L,M);
    %theatat(:,i+1)=theata;
    H=zeros(nnodes*4-1); %Set dimensions for H
    f=zeros(nnodes*4-1,1);
    felem = getfelemRev3(nele,gamma,dgamma,theata);
    [H f] = getHfRev3(H,f,felem,Helem,nele,L);
    X=H\f; %Multiply to get the X vector
    %Xt(:,i+1)=X; %Store the X vector
    xold=x;
    yold=y;
    x(1)=X(1)*dt+x(1); %Calculate coordinates for the first node
    y(1)=X(2)*dt+y(1);
    for j=2:nnodes
        x(j)=X(4+(j-2)*4)*dt+x(j); %Calculate x coordinates at end of timestep
        y(j)=X(5+(j-2)*4)*dt+y(j); %Calculate y coordinates at end of timestep
    end
    change(i)=sum((xold-x).^2)+sum((yold-y).^2);  %Formation completion
    if change(i)<1e-8
        timesteps=i;
        break;
    end
end
plot(x,y)