%Setup The Helem Matrix
function [Helem theata l] = getHelemRev3(nele,x,y,elem,L,M)

for i=1:nele
    l(i)=sqrt((x(elem(i,2))-x(elem(i,1)))^2+(y(elem(i,2))-y(elem(i,1)))^2);
    theata(i)=atan2(y(elem(i,2))-y(elem(i,1)),x(elem(i,2))-x(elem(i,1)));
    
    mu(i)=L*l(i)^2/(5*M);

    Helem(i,1,1)=2*l(i)^2*sin(theata(i))^2;
    Helem(i,1,2)=-2*l(i)^2*sin(theata(i))*cos(theata(i));
    Helem(i,1,3)=5*l(i)*sin(theata(i));
    Helem(i,1,4)=l(i)^2*sin(theata(i))^2;
    Helem(i,1,5)=-l(i)^2*sin(theata(i))*cos(theata(i));
    Helem(i,1,6)=-l(i)*sin(theata(i));
    Helem(i,1,7)=-4*l(i)*sin(theata(i));
    
    Helem(i,2,1)=Helem(i,1,2);
    Helem(i,2,2)=2*l(i)^2*cos(theata(i))^2;
    Helem(i,2,3)=-5*l(i)*cos(theata(i));
    Helem(i,2,4)=-l(i)^2*sin(theata(i))*cos(theata(i));
    Helem(i,2,5)=l(i)^2*cos(theata(i))^2;
    Helem(i,2,6)=l(i)*cos(theata(i));
    Helem(i,2,7)=4*l(i)*cos(theata(i));
 
    Helem(i,3,1)=Helem(i,1,3);
    Helem(i,3,2)=Helem(i,2,3);
    Helem(i,3,3)=14+4*mu(i);
    Helem(i,3,4)=l(i)*sin(theata(i));
    Helem(i,3,5)=-l(i)*cos(theata(i));
    Helem(i,3,6)=2-mu(i);
    Helem(i,3,7)=-16+2*mu(i);
    
    Helem(i,4,1)=Helem(i,1,4);
    Helem(i,4,2)=Helem(i,2,4);
    Helem(i,4,3)=Helem(i,3,4);
    Helem(i,4,4)=2*l(i)^2*sin(theata(i))^2;
    Helem(i,4,5)=-2*l(i)^2*sin(theata(i))*cos(theata(i));
    Helem(i,4,6)=-5*l(i)*sin(theata(i));
    Helem(i,4,7)=4*l(i)*sin(theata(i));
    
    Helem(i,5,1)=Helem(i,1,5);
    Helem(i,5,2)=Helem(i,2,5);
    Helem(i,5,3)=Helem(i,3,5);
    Helem(i,5,4)=Helem(i,4,5);
    Helem(i,5,5)=2*l(i)^2*cos(theata(i))^2;
    Helem(i,5,6)=5*l(i)*cos(theata(i));
    Helem(i,5,7)=-4*l(i)*cos(theata(i));
    
    Helem(i,6,1)=Helem(i,1,6);
    Helem(i,6,2)=Helem(i,2,6);
    Helem(i,6,3)=Helem(i,3,6);
    Helem(i,6,4)=Helem(i,4,6);
    Helem(i,6,5)=Helem(i,5,6);
    Helem(i,6,6)=14+4*mu(i);
    Helem(i,6,7)=-16+2*mu(i);
    
    Helem(i,7,1)=Helem(i,1,7);
    Helem(i,7,2)=Helem(i,2,7);
    Helem(i,7,3)=Helem(i,3,7);
    Helem(i,7,4)=Helem(i,4,7);
    Helem(i,7,5)=Helem(i,5,7);
    Helem(i,7,6)=Helem(i,6,7);
    Helem(i,7,7)=32+16*mu(i);
    
    Helem(i,:,:)=Helem(i,:,:)/(6*L*l(i));

end
mH=max(Helem(:))*1e10;
Helem(1,2,2)=mH; %Fix the endpoints in Y-dir
Helem(1,3,3)=mH; %Zero Flux
Helem(nele,4,4)=mH; %Fix the endpoints in X-dir
Helem(nele,6,6)=mH; %Zero Flux